package htc.mdb3;

import javax.naming.InitialContext;
import javax.naming.Context;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueConnection;
import javax.jms.QueueSession;
import javax.jms.Queue;
import javax.jms.QueueSender;
import javax.jms.Session;
import javax.jms.Message;
import javax.jms.TopicPublisher;
import javax.jms.ObjectMessage;
import java.util.Properties;

public class HotProductCreator {
   
    public static final String FACTORY_NAME =
                  "jms/RemoteConnectionFactory";  

    public static final String DEST_NAME = "jms/queue/test";
 
    public static InitialContext getInitialContext()  {
      Properties props = new Properties();
      InitialContext jndiCtx = null;
      try {
        props.put(Context.URL_PKG_PREFIXES,"org.jboss.ejb.client.naming");
 
        jndiCtx = new InitialContext(props);  
      }catch(Exception ex) {}
       return jndiCtx;
    }
 public static void main(String[] args) {
  try {
   Context ctx = getInitialContext();

   QueueConnectionFactory factory = 
       (QueueConnectionFactory)ctx.lookup(FACTORY_NAME);

   QueueConnection con = factory.createQueueConnection();

   QueueSession session = con.createQueueSession(false,
                              Session.AUTO_ACKNOWLEDGE);
   Queue queue = (Queue)ctx.lookup(DEST_NAME);

   QueueSender sender = session.createSender(queue);

   ObjectMessage msg = session.createObjectMessage();

   ProductDTO dto = new ProductDTO(1000,"SonyTV","A",23432.20);

   msg.setObject(dto);

   sender.send(msg);

   System.out.println("Sent Message");

   con.close();
  }catch(Exception e){
     System.out.println("error:"+e);
  }
 }

}  