package htc.mdb3;

import javax.ejb.MessageDriven;
import javax.ejb.PrePassivate;
import javax.ejb.ActivationConfigProperty;
import javax.persistence.PersistenceContext;
import javax.persistence.EntityManager;
import javax.jms.MessageListener;
import javax.jms.Message;
import javax.jms.ObjectMessage;
import javax.jms.JMSException;

@MessageDriven
(activationConfig = {
 @ActivationConfigProperty(propertyName="destinationType"  ,propertyValue="javax.jms.Queue"),
 @ActivationConfigProperty(propertyName="destination",propertyValue="jms/queue/test"),
 @ActivationConfigProperty(propertyName = "acknowledgeMode",
   propertyValue = "Auto-acknowledge")})
public  class  MsgActBean    implements   MessageListener {
 
 @PersistenceContext(unitName="myplaindb")
 EntityManager em;

 private    HotProduct    prod;

 @PrePassivate
 public void passivateEntity() {
  prod = null;
 }

 public  boolean createProduct(ProductDTO dto) {
  boolean ret = false;
  prod = new HotProduct();
  prod.setProdId(new Long(dto.getProdId()));
  prod.setProdName(dto.getName());
  prod.setProdType(dto.getType());
  prod.setProdCost(dto.getCost());
  try {
   em.persist(prod);
   ret = true;
  }
  catch(Exception e){
   System.out.println(e);
  }
  return ret;
 }

 public String getInfo(){
  StringBuilder sb = new StringBuilder();
  sb.append("Id:" + prod.getProdId());
  sb.append("\nName:" + prod.getProdName());
  sb.append("\nType:" + prod.getProdType());
  sb.append("\nCost:" + prod.getProdCost());
  return sb.toString();
 }

 public void onMessage(Message msg) {
  boolean boo = false;
  try {
   if(msg instanceof ObjectMessage){
    ObjectMessage om = (ObjectMessage)msg;
    ProductDTO prd =  (ProductDTO)om.getObject();
    boo = createProduct(prd);
    if(boo){
     System.out.println("Product is created");
     System.out.println(getInfo());
    }
   }      
  }
  catch(JMSException e) {
   e.printStackTrace();
  }
 }
  
}